<?php
/**
* @package AIP_noBDD
* @author El Konkonbr Masqued
* @copyright El Konkonbr Masqued 2012
* @version 1.0.1
* @date 08-03-2012
* @since 06-08-2012
*/
class AIP_noBDD
{
	/** 
	 * 
	 * @var string Nom de la BDD  ouvrir.
	 * 
	 */ 
	private $fichier_BDD;
	
	/**
	 * 
	 * @var int Nombre de message dans la BDD.
	 * 
	*/
	public $nb_total_messages;
	
	/**
	 * 
	 * @var string Nom du fichier qui sera ouvert pour y inscrire certaines donnes.
	 * 
	 */
	private $fichier_fw;
	
	
	/** 
	 * Constructeur permettant d'ouvrir le fichier contenant les messages de la BDD.
	 * 
	 * @param string $fichier_BDD Nom du fichier o sont stocks les messages.
	 * @example _ExemplesClass/exemple-creation-instance.txt
	 * 
	*/
	public function __construct($fichier_BDD)
	{
		if (file_exists($fichier_BDD))
		{
			$this->fichier_BDD = $fichier_BDD;
		}
		else
		{
			exit('<p align="center">Le fichier <strong>'.$fichier_BDD.'</strong> est introuvable</p>');
		}
	}


	/**
	 * Constructeur PHP4 permettant d ouvrir le fichier contenant les messages de la BDD.
	 * 
	 * @param string $fichier_BDD Nom du fichier o sont stocks les messages.
	 * @example _ExemplesClass/exemple-creation-instance.txt
	 * 
	 */
	public function AIP_noBDD($fichier_BDD)
	{
		$this->__construct($fichier_BDD);
	}

	/**
	 * Mthode retournant le nombre total de messages dans la BDD.
	 * 
	 * @return int $nb_messages
	 */
	public function Total_messages_BDD()
	{
		$tablo_mess_livre = file($this->fichier_BDD);
		$nb_messages = (count($tablo_mess_livre) - 1) / 2;
		$this->nb_total_messages = $nb_messages;
		return $nb_messages;
	}


	/**
	 * Mthode permettant d accder  la BDD.
	 * 
	 * @param array $cl_nom_tableau1
	 * @param array $cl_nom_tableau2
	 */
	public function Acces_BDD($cl_nom_tableau1, $cl_nom_tableau2)
	{
		global $nb_messages;
		global $affiche_message;
		global $nb_messages_affiches;
		
		// Ici s'affiche les variables globalises
		foreach ($cl_nom_tableau1 as $cle_glob => $valeur_trim) {eval($cle_glob);}
		foreach ($cl_nom_tableau2 as $cle_glob => $valeur_trim) {eval($cle_glob);}
		
		$tablo_mess_livre = file($this->fichier_BDD);
		$nb_messages = (count($tablo_mess_livre) - 1) / 2;
		$nb_messages_temp = 0;
		
		for ($compteur = 1; $compteur <= $nb_messages; $compteur++)
		{
			$donnees = explode('|', $tablo_mess_livre[($compteur * 2) - 1]); // NE RIEN TOUCHER ICI (Donnes de la 1re ligne)
			foreach ($cl_nom_tableau1 as $cle_glob => $valeur_trim)
			{
				eval($valeur_trim);
			}
			
			$donnees2 = explode('|', $tablo_mess_livre[($compteur * 2)]); // NE RIEN TOUCHER ICI (Donnes de la 2me ligne)
			foreach ($cl_nom_tableau2 as $cle_glob => $valeur_trim)
			{
				eval($valeur_trim);
			}
			if ($affiche_message[$compteur] == 'non')
			$nb_messages_temp++;
		}
		// On calcule le nb de messages affichs et on dcompte les messages cachs.
		$nb_messages_affiches = $nb_messages - $nb_messages_temp;
	}


	#-----
	# Utilis dans livre_signer.php
	/**
	 * M&eacute;thode permettant d ajouter des donn&eacute;es dans la BDD.
	 * 
	 * @param array $cl_nom_tableau
	 */
	public function Ajout_donnees($cl_nom_tableau)
	{
		$fichier = fopen($this->fichier_BDD, 'a+');
		
		foreach ($cl_nom_tableau as $valeur)
		{
			fwrite($fichier, $valeur.'|');
		}
		fwrite($fichier, "\n");
		fclose($fichier);
	}


	#-----
	# Utilis dans suppression_livre.php
	/**
	 * AIP_noBDD::Reecriture_donnees()
	 * 
	 * @param array $cl_nom_tableau1
	 * @param array $cl_nom_tableau2
	 * @param string $ligne_amorce
	 */
	public function Reecriture_donnees($cl_nom_tableau1, $cl_nom_tableau2, $ligne_amorce)
	{
		global $nb_messages, $nb_mess_reecrit; // Sert  la boucle et compte le nombre de messages supprim ...

		$fichier = fopen($this->fichier_BDD, 'w+');  // On ouvre livre.txt
		fwrite($fichier, $ligne_amorce);
		$nb_mess_reecrit = 0;

		for ($compteur = 1; $compteur <= $nb_messages; $compteur++)
		{
			//if (isset($_POST['c'.$compteur.'']) != 'on') // A voir : concat inutile
			if (isset($_POST['c'.$compteur]) != 'on')
			{
				foreach ($cl_nom_tableau1 as $cle_glob => $valeur_trim)
				{
					fwrite($fichier, $valeur_trim[$compteur].'|');
				}
				fwrite($fichier, "\n");
				
				foreach ($cl_nom_tableau2 as $cle_glob => $valeur_trim)
				{
					fwrite($fichier, $valeur_trim[$compteur].'|');
				}
				fwrite($fichier, "\n");

				$nb_mess_reecrit++;
			}
		}
		fclose($fichier);
	}


	#-----
	# Utilis dans edit.php
	/**
	 * AIP_noBDD::Reecriture_seulement_une_ligne()
	 * 
	 * @param array $cl_nom_tableau1_a_reecrire
	 * @param array $cl_nom_tableau2_a_reecrire
	 * @param array $cl_nom_tableau1_a_modifier
	 * @param array $cl_nom_tableau2_a_modifier
	 * @param string $ligne_amorce
	 * @param int $id_a_trouver
	 */
	public function Reecriture_seulement_une_ligne($cl_nom_tableau1_a_reecrire, $cl_nom_tableau2_a_reecrire, $cl_nom_tableau1_a_modifier, $cl_nom_tableau2_a_modifier, $ligne_amorce, $id_a_trouver)
	{
		global $nb_messages; // Sert  la boucle.
		
		$fichier = fopen($this->fichier_BDD, 'w+');      // On ouvre livre.txt
		fwrite($fichier, $ligne_amorce);
		
		for ($compteur = 1; $compteur <= $nb_messages; $compteur++)
		{
			if ($id_a_trouver != $compteur)
			{
				foreach ($cl_nom_tableau1_a_reecrire as $valeur)
				{
					fwrite($fichier, $valeur[$compteur].'|');
				}
				fwrite($fichier, "\n");
				
				foreach ($cl_nom_tableau2_a_reecrire as $valeur)
				{
					fwrite($fichier, $valeur[$compteur].'|');
				}
				fwrite($fichier, "\n");
			}
			elseif ($id_a_trouver == $compteur)
			{
				foreach ($cl_nom_tableau1_a_modifier as $valeur)
				{
					fwrite($fichier, $valeur.'|');
				}
				fwrite($fichier, "\n");
				
				foreach ($cl_nom_tableau2_a_modifier as $valeur)
				{
					fwrite($fichier, $valeur.'|');
				}
				fwrite($fichier, "\n");
			}
		}
	}


	/*
	Permet d'crire l'entte d'un fichier de la Bdd
	*/
	/**
	 * AIP_noBDD::Ecrire_ouverture_balise_SQL()
	 * 
	 * @param string $ligne1 Correspond au titre
	 * @param string $ligne2
	 * @param string $ligne3
	 * 
	 */
	public function Ecrire_ouverture_balise_SQL($ligne1, $ligne2, $ligne3)
	{
		$date_mod = date('d-m-Y*H:i'); // Pour enregistrer la date de la dernire modification
		$this->fichier_fw = fopen ($this->fichier_BDD, 'w+'); // w modifi en w+
		fwrite ($this->fichier_fw, "<?php\n");
		fwrite ($this->fichier_fw, "############################################# \n");
		fwrite ($this->fichier_fw, "#              Base de donnes              # \n");
		fwrite ($this->fichier_fw, "############################################# \n");
		//fwrite ($this->fichier_fw, "#               Les categories              # \n");
		//fwrite ($this->fichier_fw, "#              BDD des membres              # \n");
		fwrite ($this->fichier_fw, $ligne1);
		fwrite ($this->fichier_fw, "#              Dernier accs :              #\n");
		fwrite ($this->fichier_fw, "#             $date_mod              #\n");
		fwrite ($this->fichier_fw, "############################################# \n");
		//fwrite ($this->fichier_fw, "# Organisation : ID auto | Nom catgorie\n\n");
		fwrite ($this->fichier_fw, $ligne2);
		//fwrite ($this->fichier_fw, "\$bdd_reponses_au_sujet = array(\n");
		fwrite ($this->fichier_fw, $ligne3);
	}


	/*
	Permet de clore la fonction ci-dessus "Ecrire_ouverture_balise($ligne1, $ligne2, $ligne3)"
	*/
	/**
	 * AIP_noBDD::Ecrire_fermeture_balise_SQL()
	 * 
	 */
	public function Ecrire_fermeture_balise_SQL()
	{
		fwrite ($this->fichier_fw, ");\n\n");
		fwrite ($this->fichier_fw, "?>");
		fclose ($this->fichier_fw);
	}


	#----------------------------------- AJOUTER UNE NOUVELLE DONNEE

	/* REECRIRE ANCIENNES DONNEES. <<< Dans le 1er temps.
	Dans 1 fichier contenant plusieurs lignes de donnes, une seule est ajoute  la fin.
	Il faut donc recrire les autres premires lignes sans la moindre modification.
	On ajoute par la mme occasion, la photo et sa miniature.
	
	$nb_colonne		: C'est le nb de colonne du tableau "$les_donnees" (On commence  compter  partir de un), donc ici 7 colonnes.
	$nom_du_tableau	: $les_donnees = array('non', '20070201010903', '7', '25', 'Un ballon', 'image7.jpg', 'commentaire') etc... Ici $nom_du_tableau est $les_donnees
	
	Ici on recrit les autres premires lignes sans modification.
	
	Fonction utilise ds : livre_signer.php
	*/
	/**
	 * AIP_noBDD::Reecrire_anciennes_donnees_SQL()
	 * 
	 * @param int $nb_colonne
	 * @param array $nom_du_tableau
	 */
	public function Reecrire_anciennes_donnees_SQL($nb_colonne, $nom_du_tableau) // $tableau
	{
		//global $fichier;
		
		for ($i = 0; $i < count($nom_du_tableau); $i++)
		{
			fwrite($this->fichier_fw, 'array (');
			
			for ($a = 0; $a < $nb_colonne; $a++)
			{
				if ($a != ($nb_colonne - 1))
				{
					$virgule = ','; $espace = ' ';
				}
				else
				{
					$virgule = ''; $espace = ''; // supp derniere virgule
				}
				// Sert lors de la reecriture de toutes les autres lignes.
				// Ok MQgpc 0 ou 1
				$nom_du_tableau[$i][$a] = str_replace('\\', '\\\\', $nom_du_tableau[$i][$a]); // Dans cet ordre impratif.
				$nom_du_tableau[$i][$a] = str_replace('\'', '\\\'', $nom_du_tableau[$i][$a]);
				
				fwrite($this->fichier_fw, '\''.$nom_du_tableau[$i][$a].'\''.$virgule.$espace.'');
			}
			fwrite($this->fichier_fw, '),');
			fwrite($this->fichier_fw, "\n");
		}
	}


	/* AJOUTER UNE NOUVELLE DONNEE. <<< Dans le 2me temps.
	Dans 1 fichier contenant plusieurs lignes de donnes, une seule est ajoute  la fin.
	Il faut donc recrire les autres premires lignes sans la moindre modification.
	On ajoute par la mme occasion, la photo et sa miniature.
	
	Ici on ajoute la nouvelle donne  la fin.
	
	$nb_colonne		: C'est le nb de colonne du tableau "$les_donnees" (On commence  compter  partir de un), donc ici 7 colonnes.
					Ici $nb_colonne sert uniquement  la gestion de la dernire virgule.
	$tableau_array	: $les_donnees = array('non', '20070201010903', '7', '25', 'Un ballon', 'image7.jpg', 'commentaire') etc... Ici $nom_du_tableau est $les_donnees
	
	
	Fonction utilise ds : livre_signer.php
	*/
	/**
	 * AIP_noBDD::Ajouter_nouvelle_donnee_SQL()
	 * 
	 * @param int $nb_colonne
	 * @param array $tableau_array
	 */
	public function Ajouter_nouvelle_donnee_SQL($nb_colonne, $tableau_array)
	{
		// Ecriture de la nouvelle ligne
		fwrite($this->fichier_fw, 'array (');
		$cpt_dep = 1;
		foreach ($tableau_array as $valeur)
		{
			if (count($tableau_array) != $cpt_dep)
			{
				$virgule = ','; $espace = ' ';
			}
			else
			{
				$virgule = ''; $espace = '';  // supp derniere virgule
			}
			fwrite($this->fichier_fw, '\''.$valeur.'\''.$virgule.$espace.'');
			$cpt_dep++;
		}
		fwrite($this->fichier_fw, '),');
		fwrite($this->fichier_fw, "\n");
	}
	#------------------------------------------------------------------------------- 


	#-------------------------------------------------------------------------------
	/* REECRIRE SEULEMENT UNE LIGNE
	Dans 1 fichier contenant plusieurs lignes de donnes, une seule est rcrite avec de nouvelles donnes.
	Les autres sont rcrites sans la moindre modification.
	
	$nom_du_tableau							: $les_donnees = array('non', '20070201010903', '7', '25', 'Un ballon', 'image7.jpg', 'commentaire') etc... Ici $nom_du_tableau est $les_donnees
	$nb_colonne								: C'est le nb de colonne du tableau "$les_donnees" (On commence  compter  partir de un), donc ici 7 colonnes.
	$colonne_ou_trouver_id_pour_comparaison	: Ds notre tableau ci-dessus $id_a_trouver_URL_ou_hidden est la valeur 7 qui se trouve  la position 2. La $colonne_ou_trouver_id_pour_comparaison est la colonne ou se trouve "7". On commence  compter  partir de zro.
	$id_a_trouver_URL_ou_hidden				: Identifiant gnralement en provenance d'un input hidden ou de l'URL (GET).
	$tableau_array							: On met sous forme d'array les donnes de la ligne  modifier.
	
	Fonction utilise ds : admin.php
	*/
	/**
	 * AIP_noBDD::Reecrire_seulement_une_ligne_SQL()
	 * 
	 * @param array $nom_du_tableau
	 * @param int $nb_colonne
	 * @param int $colonne_ou_trouver_id_pour_comparaison
	 * @param int $id_a_trouver_URL_ou_hidden
	 * @param array $tableau_array
	 */
	public function Reecrire_seulement_une_ligne_SQL($nom_du_tableau, $nb_colonne, $colonne_ou_trouver_id_pour_comparaison, $id_a_trouver_URL_ou_hidden, $tableau_array) // $tableau_array
	{
		for ($i = 0; $i < count($nom_du_tableau); $i++)
		{
			if ($nom_du_tableau[$i][$colonne_ou_trouver_id_pour_comparaison] == $id_a_trouver_URL_ou_hidden)
			{
				// Ecriture de la nouvelle ligne
				fwrite($this->fichier_fw, 'array (');
				
				foreach ($tableau_array as $valeur)
				{
					fwrite($this->fichier_fw, '\''.$valeur.'\', '); // VIRGULE a Supprimer
				}
				fwrite($this->fichier_fw, '),');
				fwrite($this->fichier_fw, "\n");
			}
			else
			{
				fwrite($this->fichier_fw, 'array (');
				
				for ($a = 0; $a < $nb_colonne; $a++)
				{
					if ($a != ($nb_colonne - 1))
					{
						$virgule = ','; $espace = ' ';
					}
					else
					{
						$virgule = ''; $espace = '';
					} // supp derniere virgule
					
					// Sert lors de la reecriture de toutes les autres lignes.
					// Ok MQgpc 0 ou 1
					$nom_du_tableau[$i][$a] = str_replace('\\', '\\\\', $nom_du_tableau[$i][$a]); // Dans cet ordre impratif.
					$nom_du_tableau[$i][$a] = str_replace('\'', '\\\'', $nom_du_tableau[$i][$a]);
					
					fwrite($this->fichier_fw, '\''.$nom_du_tableau[$i][$a].'\''.$virgule.$espace.'');
				}
				fwrite($this->fichier_fw, '),');
				fwrite($this->fichier_fw, "\n");
			}
		}
	}
	#-------------------------------------------------------------------------------


	## Fonctions diverses
	/*
	$nom_du_tableau							: $les_donnees = array('non', '20070201010903', '7', '25', 'Un ballon', 'image7.jpg', 'commentaire') etc... Ici $nom_du_tableau est $les_donnees
	$id_a_trouver_URL_ou_hidden				: Identifiant gnralement en provenance d'un input hidden ou de l'URL (GET)
	$colonne_ou_trouver_id_pour_comparaison	: Ds notre tableau ci-dessus $id_a_trouver_URL_ou_hidden est la valeur 7 qui se trouve  la position 2. La $colonne_ou_trouver_id_pour_comparaison est la colonne ou se trouve "7". On commence  compter  partir de zro.
	Ce qui donne							: Bdd_scan_ligne_a_modifier($les_donnees, $variable_correspondant_a_7, 2)
	
	Fonction utilise ds : form_mess_accueil.php
	*/
	/**
	 * AIP_noBDD::Bdd_scan_ligne_a_modifier_SQL()
	 * 
	 * @param array $nom_du_tableau
	 * @param int $id_a_trouver_URL_ou_hidden
	 * @param int $colonne_ou_trouver_id_pour_comparaison
	 * @return int $ligne_a_modifier_Class
	 */
	public function Bdd_scan_ligne_a_modifier_SQL($nom_du_tableau, $id_a_trouver_URL_ou_hidden, $colonne_ou_trouver_id_pour_comparaison)
	{
		$trouve = '';
		$nouvelle_ligne = '';
		for ($i = 0; $i < count($nom_du_tableau); $i++)
		{
			if ($nom_du_tableau[$i][$colonne_ou_trouver_id_pour_comparaison] == $id_a_trouver_URL_ou_hidden)
			{
				$ligne_a_modifier_Class = $i;
				$trouve = 'oui';
				$nouvelle_ligne = 'non';
			}
		}
		
		if ($trouve != 'oui')
		{
			$ligne_a_modifier_Class = 0;
			$nouvelle_ligne = 'oui';
		}
		return $ligne_a_modifier_Class;
	}


	/**
	 * AIP_noBDD::Reecrire_toutes_les_lignes_idem_SQL()
	 * 
	 * @param array $nom_du_tableau
	 * @param int $nb_colonne
	 * @param string $interface
	 * @param array $tableau_array
	 */
	public function Reecrire_toutes_les_lignes_idem_SQL($nom_du_tableau, $nb_colonne, $interface, $tableau_array) // $tableau_array
	{
		for ($i = 0; $i < count($nom_du_tableau); $i++)
		{

			if ($nom_du_tableau[$i][0] == 'defaut')
			{
				####
				fwrite($this->fichier_fw, 'array (');

				for ($a = 0; $a < $nb_colonne; $a++)
				{
					if ($a != ($nb_colonne - 1))
					{
						$virgule = ','; $espace = ' ';
					}
					else
					{
						$virgule = ''; $espace = '';
					} // supp derniere virgule

					// Sert lors de la reecriture de toutes les autres lignes.
					// Ok MQgpc 0 ou 1
					$nom_du_tableau[$i][$a] = str_replace('\\', '\\\\', $nom_du_tableau[$i][$a]); // Dans cet ordre impratif.
					$nom_du_tableau[$i][$a] = str_replace('\'', '\\\'', $nom_du_tableau[$i][$a]);
					
					fwrite($this->fichier_fw, '\''.$nom_du_tableau[$i][$a].'\''.$virgule.$espace.'');
				}
				fwrite($this->fichier_fw, '),');
				fwrite($this->fichier_fw, "\n");
			}
			else
			{
				// Ecriture de la nouvelle ligne
				fwrite($this->fichier_fw, 'array (');
				
				for ($a = 0; $a < $nb_colonne; $a++)
				{
					if ($a != ($nb_colonne - 1))
					{
						$virgule = ','; $espace = ' ';
					}
					else  // supp derniere virgule
					{
						$virgule = ''; $espace = '';
					}
					
					if ($interface == 'lecture') // Message d'accueil du ct de lecture.
					{
						if ($a == 0 or $a == 2)
						{
							// Sert lors de la reecriture de toutes les autres lignes.
							// Ok MQgpc 0 ou 1
							$nom_du_tableau[$i][$a] = str_replace('\\', '\\\\', $nom_du_tableau[$i][$a]); // Dans cet ordre impratif.
							$nom_du_tableau[$i][$a] = str_replace('\'', '\\\'', $nom_du_tableau[$i][$a]);
							
							fwrite($this->fichier_fw, '\''.$nom_du_tableau[$i][$a].'\''.$virgule.$espace.'');
						}
						else
						{
							fwrite($this->fichier_fw, '\''.$tableau_array.'\', ');
						}
					}
					else  // Message d'accueil du ct de signature.
					{
						if ($a == 0 or $a == 1)
						{
							// Sert lors de la reecriture de toutes les autres lignes.
							// Ok MQgpc 0 ou 1
							$nom_du_tableau[$i][$a] = str_replace('\\', '\\\\', $nom_du_tableau[$i][$a]); // Dans cet ordre impratif.
							$nom_du_tableau[$i][$a] = str_replace('\'', '\\\'', $nom_du_tableau[$i][$a]); 

							fwrite($this->fichier_fw, '\''.$nom_du_tableau[$i][$a].'\''.$virgule.$espace.'');
						}
						else
						{
							fwrite($this->fichier_fw, '\''.$tableau_array.'\', ');
						}
					}

				}
				fwrite($this->fichier_fw, '),');
				fwrite($this->fichier_fw, "\n");
			}
		}
	}
#-------------------------------------------------------------------------------
} // FIN de la classe
?>